<template>
    <div>
        <div class="hidden">
            <input type="text" name="content" v-model="json">
        </div>

        <div class="editor" :class="editor_classes">
            <editor-menu-bar :editor="editor" v-slot="{ commands, isActive }">
                <div class="menubar text-neutral-200" :class="menubar_classes">

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        :class="{ 'text-primary-500': isActive.bold() }"
                        @click="commands.bold"
                    >
                        <i class="fad fa-bold fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        :class="{ 'text-primary-500': isActive.italic() }"
                        @click="commands.italic"
                    >
                        <i class="fad fa-italic fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        :class="{ 'text-primary-500': isActive.strike() }"
                        @click="commands.strike"
                    >
                        <i class="fad fa-strikethrough fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        :class="{ 'text-primary-500': isActive.underline() }"
                        @click="commands.underline"
                    >
                        <i class="fad fa-underline fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        :class="{ 'text-primary-500': isActive.code() }"
                        @click="commands.code"
                    >
                        <i class="fad fa-code fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        :class="{ 'text-primary-500': isActive.paragraph() }"
                        @click="commands.paragraph"
                    >
                        <i class="fad fa-paragraph fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        :class="{ 'text-primary-500': isActive.heading({ level: 1 }) }"
                        @click="commands.heading({ level: 1 })"
                    >
                        <i class="fad fa-h1 fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        :class="{ 'text-primary-500': isActive.heading({ level: 2 }) }"
                        @click="commands.heading({ level: 2 })"
                    >
                        <i class="fad fa-h2 fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        :class="{ 'text-primary-500': isActive.heading({ level: 3 }) }"
                        @click="commands.heading({ level: 3 })"
                    >
                        <i class="fad fa-h3 fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        :class="{ 'text-primary-500': isActive.bullet_list() }"
                        @click="commands.bullet_list"
                    >
                        <i class="fad fa-list-ul fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        :class="{ 'text-primary-500': isActive.ordered_list() }"
                        @click="commands.ordered_list"
                    >
                        <i class="fad fa-list-ol fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        :class="{ 'text-primary-500': isActive.blockquote() }"
                        @click="commands.blockquote"
                    >
                        <i class="fad fa-quote-right fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        :class="{ 'text-primary-500': isActive.code_block() }"
                        @click="commands.code_block"
                    >
                        <i class="fad fa-code fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        @click="commands.horizontal_rule"
                    >
                        <i class="fad fa-horizontal-rule fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        @click="commands.undo"
                    >
                        <i class="fad fa-undo fa-fw"></i>
                    </button>

                    <button
                        type="button"
                        class="menubar__button hover:text-primary-500"
                        @click="commands.redo"
                    >
                        <i class="fad fa-redo fa-fw"></i>
                    </button>

                </div>
            </editor-menu-bar>

            <editor-content :editor="editor" />
        </div>
    </div>
</template>

<script>
    import { Editor, EditorContent, EditorMenuBar } from 'tiptap'
    import {
        Blockquote,
        CodeBlock,
        HardBreak,
        Heading,
        HorizontalRule,
        OrderedList,
        BulletList,
        ListItem,
        TodoItem,
        TodoList,
        Bold,
        Code,
        Italic,
        Link,
        Strike,
        Underline,
        History,
    } from 'tiptap-extensions';

    const extensions = [
        new Blockquote(),
        new BulletList(),
        new CodeBlock(),
        new HardBreak(),
        new Heading({ levels: [1, 2, 3] }),
        new HorizontalRule(),
        new ListItem(),
        new OrderedList(),
        new TodoItem(),
        new TodoList(),
        new Link(),
        new Bold(),
        new Code(),
        new Italic(),
        new Strike(),
        new Underline(),
        new History(),
    ];

    export default {
        name: "EditorComponent.vue",
        components: {
            EditorContent,
            EditorMenuBar,
        },
        props: ["value", "content", "editor_classes", "menubar_classes"],
        data() {
            return {
                editor: new Editor({
                    onUpdate: ({ getJSON }) => {
                        this.editorChange = true;
                        this.$emit("input", getJSON());

                        this.json = JSON.stringify(getJSON())
                    },
                    extensions: extensions
                }),
                editorChange: false,
                json: null
            };
        },
        mounted() {

            if (this.content != null){
                this.editor.setContent(JSON.parse(this.content));
                this.json = this.content;
            }

        },

        beforeDestroy() {
            this.editor.destroy()
        },

        watch: {
            value(val) {

                if (this.editor && !this.editorChange) {
                    this.editor.setContent(val, true);
                }
                this.editorChange = false;
            }
        }
    }
</script>
